package example
{
	import org.puremvc.interfaces.IProxy;
	import org.puremvc.patterns.facade.Facade;
	import org.puremvc.interfaces.INotification;
	import org.puremvc.interfaces.IFacade;
	import org.puremvc.interfaces.IMediator;
	import example.controller.*;
	/**
	 * アプリケーションの根幹の振る舞いを書くところ
	 */
	public class ApplicationFacade extends Facade implements IFacade
	{
		public static const APP_START_UP:String = "appStartUp";
		public static const APP_NUMBER_CLICK:String = "appNumberButtonClick";
		public static const APP_PLUS_CLICK:String = "appPlusButtonClick";
		public static const APP_MINUS_CLICK:String = "appMinusButtonClick";
		public static const APP_EQUAL_CLICK:String = "appEqualButtonClick";
		public static const APP_CLEAR_CLICK:String = "appClearButtonClick";
		/**
		 * インスタンスを取得するメソッド
		 * @return ApplicationFacade
		 */
		public static function getInstance():ApplicationFacade
		{
			// 静的インスタンスの判定
			if( instance == null )
			{
				// インスタンスが生成されていなければインスタンス化
				instance = new ApplicationFacade();
			}
			return instance as ApplicationFacade;
		}
		/**
		 * Facadeクラスの初期化
		 * ここでは最初に実行されるコマンドを登録する
		 */
		override protected function initializeController():void
		{
			// 親クラスの初期化
			super.initializeController();
			// AppStartUpCommandというクラスをAPP_START_UPというイベントと関連付け
			registerCommand(APP_START_UP,AppStartUpCommand);
		}
	}
}