package example.view
{
	import org.puremvc.patterns.mediator.Mediator;
	import org.puremvc.interfaces.INotification;
	import org.puremvc.interfaces.IMediator;
	import example.model.CalclationProxy;
	import example.view.components.CalclationPanel;
	import flash.events.Event;
	import example.ApplicationFacade;
	import example.view.vo.CalclationVO;
	public class CalclationPanelMediator extends Mediator implements IMediator
	{
		private var proxy:CalclationProxy;
		public static const NAME:String = "CalclationPanelMediator";
		/**
		 * コンストラクタ
		 * ここではこのMediatorクラスで発生するイベントのリスナを登録
		 */
		public function CalclationPanelMediator(view:Object):void
		{
			// 親クラスのコンストラクタの呼び出し
			super(view);
			// ハンドラの登録
			calclationForm.addEventListener(CalclationPanel.click0,onClick);
			calclationForm.addEventListener(CalclationPanel.click1,onClick);
			calclationForm.addEventListener(CalclationPanel.click2,onClick);
			calclationForm.addEventListener(CalclationPanel.click3,onClick);
			calclationForm.addEventListener(CalclationPanel.click4,onClick);
			calclationForm.addEventListener(CalclationPanel.click5,onClick);
			calclationForm.addEventListener(CalclationPanel.click6,onClick);
			calclationForm.addEventListener(CalclationPanel.click7,onClick);
			calclationForm.addEventListener(CalclationPanel.click8,onClick);
			calclationForm.addEventListener(CalclationPanel.click9,onClick);
			calclationForm.addEventListener(CalclationPanel.clickMinus,onClick);
			calclationForm.addEventListener(CalclationPanel.clickPlus,onClick);
			calclationForm.addEventListener(CalclationPanel.clickClear,onClick);
			calclationForm.addEventListener(CalclationPanel.clickEqual,onClick);
			// facadeインスタンスに登録されたproxyクラス（ロジック実装クラス）を取得
			proxy = facade.retrieveProxy( CalclationProxy.NAME ) as CalclationProxy;
		}
		/**
		 * プロパティアクセサ
		 */
		public function get calclationForm():CalclationPanel
		{
			return viewComponent as CalclationPanel;
		}
		/**
		 * イベントハンドラ
		 * ここではCalclationPanelのイベントであるclick0などの
		 * イベントを解析している
		 */
		private function onClick(e:Event):void
		{
			// VIEWコンポーネント（プロパティアクセサ）からVOを取得
			var calc:CalclationVO = calclationForm.calcVO;
			// イベントタイプにより処理の振り分け
			switch( e.type )
			{
				case CalclationPanel.click0:
					proxy.setNumber("0");
					sendNotification(ApplicationFacade.APP_NUMBER_CLICK, calc);
					break;
				case CalclationPanel.click1:
					proxy.setNumber("1");
					sendNotification(ApplicationFacade.APP_NUMBER_CLICK, calc);
					break;
				case CalclationPanel.click2:
					proxy.setNumber("2");
					sendNotification(ApplicationFacade.APP_NUMBER_CLICK, calc);
					break;
				case CalclationPanel.click3:
					proxy.setNumber("3");
					sendNotification(ApplicationFacade.APP_NUMBER_CLICK, calc);
					break;
				case CalclationPanel.click4:
					proxy.setNumber("4");
					sendNotification(ApplicationFacade.APP_NUMBER_CLICK, calc);
					break;
				case CalclationPanel.click5:
					proxy.setNumber("5");
					sendNotification(ApplicationFacade.APP_NUMBER_CLICK, calc);
					break;
				case CalclationPanel.click6:
					proxy.setNumber("6");
					sendNotification(ApplicationFacade.APP_NUMBER_CLICK, calc);
					break;
				case CalclationPanel.click7:
					proxy.setNumber("7");
					sendNotification(ApplicationFacade.APP_NUMBER_CLICK, calc);
					break;
				case CalclationPanel.click8:
					proxy.setNumber("8");
					sendNotification(ApplicationFacade.APP_NUMBER_CLICK, calc);
					break;
				case CalclationPanel.click9:
					proxy.setNumber("9");
					sendNotification(ApplicationFacade.APP_NUMBER_CLICK, calc);
					break;
				case CalclationPanel.clickMinus:
					sendNotification(ApplicationFacade.APP_MINUS_CLICK, calc);
					break;
				case CalclationPanel.clickPlus:
					sendNotification(ApplicationFacade.APP_PLUS_CLICK, calc);
					break;
				case CalclationPanel.clickClear:
					sendNotification(ApplicationFacade.APP_CLEAR_CLICK, calc);
					break;
				case CalclationPanel.clickEqual:
					sendNotification(ApplicationFacade.APP_EQUAL_CLICK, calc);
					break;
			}
		}
		/**
		 * このMediatorクラスで発生するイベントの登録をする
		 */
		override public function listNotificationInterests():Array
		{
			// ここに列挙された文字列をこのクラスの中ではハンドルすることにより、
			// 処理の振り分けを行う。
			return [
				ApplicationFacade.APP_NUMBER_CLICK,
				ApplicationFacade.APP_PLUS_CLICK,
				ApplicationFacade.APP_MINUS_CLICK,
				ApplicationFacade.APP_CLEAR_CLICK,
				ApplicationFacade.APP_EQUAL_CLICK
					];
		}
		/**
		 * listNotificationInterestsメソッドで登録された文字列を
		 * 実際に処理に振り分ける
		 */
		override public function handleNotification(notification:INotification):void
		{
			switch ( notification.getName() )
			{
				case ApplicationFacade.APP_NUMBER_CLICK:
					// 画面に表示している情報（VO）の取得
					calclationForm.calcVO = notification.getBody() as CalclationVO;
					// 画面に表示している情報の書き換え
					calclationForm.calcVO.calcString = proxy.calcString;
					break;
				case ApplicationFacade.APP_PLUS_CLICK:
					proxy.plusNumber();
					break;
				case ApplicationFacade.APP_MINUS_CLICK:
					proxy.minusNumber();
					break;
				case ApplicationFacade.APP_CLEAR_CLICK:
					proxy.clear();
					// 画面に表示している情報の書き換え
					calclationForm.calcVO.calcString = proxy.calcString;
					break;
				case ApplicationFacade.APP_EQUAL_CLICK:
					proxy.calcEqual();
					// 画面に表示している情報の書き換え
					calclationForm.calcVO.calcString = proxy.calcString;
					break;
					
			}
		}
	}
}